# hako-svg.cgi svgط
# ץȺchanon
# Ȣۥ : http://hakodama.net/
# ----------------------------------------------------

# 
sub makeNightSky {
  my($svg1, $svg2, $svg25, $svg3);

  # إå
  $svg1=<<_HEADER_;
<?xml version="1.0" standalone="no"?>
<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
width="600" height="400" viewBox="-300 -350 600 400">
  <meta http-equiv="Content-Script-Type" content="text/javascript" />
  <defs>
    <script type="text/javascript">
      <![CDATA[
        function setStarName(evt, name) {
          var text = evt.getTarget().getOwnerDocument().getElementById("starname");
          text.getFirstChild().setData(name);
        }
      ]]>
    </script>
    <radialGradient id="moon" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="khaki" stop-opacity="1" offset="0.6" />
      <stop stop-color="khaki" stop-opacity="0.2" offset="0.7" />
      <stop stop-color="khaki" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star0" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="khaki" stop-opacity="1" offset="0.3" />
      <stop stop-color="khaki" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star1" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="darkviolet" stop-opacity="1" offset="0.3" />
      <stop stop-color="darkviolet" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star2" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="red" stop-opacity="1" offset="0.3" />
      <stop stop-color="red" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star3" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="skyblue" stop-opacity="1" offset="0.3" />
      <stop stop-color="skyblue" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star4" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="aquamarine" stop-opacity="1" offset="0.3" />
      <stop stop-color="aquamarine" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star5" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="white" stop-opacity="1" offset="0.3" />
      <stop stop-color="white" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star6" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="gray" stop-opacity="1" offset="0.3" />
      <stop stop-color="gray" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star7" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="hotpink" stop-opacity="1" offset="0.3" />
      <stop stop-color="hotpink" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star8" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="white" stop-opacity="1" offset="0.3" />
      <stop stop-color="white" stop-opacity="0" offset="1" />
    </radialGradient>
    <radialGradient id="star9" gradientUnit="objectBoundingBox" cx="0.5" cy="0.5">
      <stop stop-color="royalblue" stop-opacity="1" offset="0.3" />
      <stop stop-color="royalblue" stop-opacity="0" offset="1" />
    </radialGradient>
  </defs>
  <rect x="-300" y="-350" width="600" height="400" style="fill:#000020;"/>
  <g>
    <g>
_HEADER_

  # եå
  $svg3=<<_HEADER_;
  <rect x="-300" y="0" width="600" height="50" style="fill:#002000;"/>
  <text id="starname" x="0" y="30" font-size="20" fill="white" text-anchor="middle">ξ</text>
</svg>
_HEADER_

  # 
  my($i, $j);
  for($i=0; $i<($HstarNumber - $HstarDelay); $i++) {
    my($line, $name, $names, $x, $y);
    $line = $Hstars[$i]->{'star'};
    if($line =~ /^(.*)([0-9]*)$/) {
      # 
      $name = $1;
      $names= $2;
    } else {
      # 
      $name = $line;
    }
    for($j=0;$j<$#Hsatellites+1;$j++) {
      # ̾ȥޥå󥰤κɸ
      if($Hsatellites[$j]->{'name'} eq $name) {
        $x = $Hsatellites[$j]->{'x'};
        $y = $Hsatellites[$j]->{'y'};
        last;
      }
    }
    if($names ne '') {
      # ϰ֤ˤ餮
      $x += rrandom(10) - 5;
      $y += rrandom(10) - 5;
    }
    # ̾򸵤᤹
    if($names ne '') {
      $name = $name . "" . $names . "";
    }
    # 礭
    my($size) = 4 * (1/1.25) ** $Hstars[$i]->{'bright'};
    # μ
    my($sign) = "\#star" . $Hstars[$i]->{'sign'};
    if($Hstars[$i]->{'delay'} == 0) {
      if($Hstars[$i]->{'sign'} == 0) {
        # 
        $svg25 .= <<_HEADER_;
      <circle cx="${x}" cy="${y}" r="$size" style="fill:url(${sign});" onmouseover="setStarName(evt,'$name');"/>
_HEADER_
      } elsif($Hstars[$i]->{'sign'} == 8) {
      # 
      } else {
        $svg2 .= <<_HEADER_;
      <circle cx="${x}" cy="${y}" r="$size" style="fill:url(${sign});" onmouseover="setStarName(evt,'$name');"/>
_HEADER_
      }
    }
  }
  # ¬֤Τ
  my($timef) = random(360);
  my($timet) = $timef - 360;
  my($mtimef) = random(360);
  my($mtimet) = $mtimef - 360;
  $svg2 .= <<_HEADER_;
      <animate attributeType="CSS" attributeName="opacity" values="1;0.4;1" dur="3s" repeatCount="indefinite"/>
    </g>
$svg25
    <animateTransform attributeName="transform" attributeType="XML"
      additive="sum" type="rotate" values="${timef};${timet}" dur="1000s" repeatCount="indefinite"/>
  </g>
  <g>
     <circle cx="0" cy="-300" r="15" style="fill:url(#moon);" onmouseover="setStarName(evt,'');">
       <animate attributeType="XML" attributeName="cy" values="-300;-250;-300" dur="10000s" repeatCount="indefinite"/>
    </circle>
    <animateTransform attributeName="transform" attributeType="XML"
      additive="sum" type="rotate" values="${mtimef};${mtimet}" dur="950s" repeatCount="indefinite"/>
   </g>
_HEADER_


  open(SVG, ">${htmlPath}nightsky.svg");
  print SVG jcode($svg1)->utf8;
  print SVG jcode($svg2)->utf8;
  print SVG jcode($svg3)->utf8;
  close (SVG);
  chmod(0606,"${htmlPath}nightsky.svg");
}

1;
